<?php
namespace Pinpoint\RedirectManager\Api;

use Pinpoint\RedirectManager\Api\Data\RedirectInterface;
use Magento\Framework\Api\SortOrder;
use Magento\Framework\Api\SearchCriteriaInterface;

/**
 * Interface RedirectRepositoryInterface
 * @package Pinpoint\RedirectManager\Api
 */
interface RedirectRepositoryInterface
{
    /**
     * @param RedirectInterface $page
     * @return mixed
     */
    public function save(RedirectInterface $page);

    /**
     * @param $id
     * @return mixed
     */
    public function getById($id);

    /**
     * @param SearchCriteriaInterface $criteria
     * @return mixed
     */
    public function getList(SearchCriteriaInterface $criteria);

    /**
     * @param RedirectInterface $page
     * @return mixed
     */
    public function delete(RedirectInterface $page);

    /**
     * @param $id
     * @return mixed
     */
    public function deleteById($id);
}
