<?php
namespace Pinpoint\RedirectManager\Model;
/**
 * Class Redirect
 * @package Pinpoint\RedirectManager\Model
 */
class Redirect extends \Magento\Framework\Model\AbstractModel implements \Pinpoint\RedirectManager\Api\Data\RedirectInterface, \Magento\Framework\DataObject\IdentityInterface
{
    /**
     * @var string
     */
    const CACHE_TAG = 'pinpoint_redirectmanager_redirect';

    protected function _construct()
    {
        $this->_init('Pinpoint\RedirectManager\Model\ResourceModel\Redirect');
    }

    /**
     * @return array
     */
    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getId()];
    }

    /**
     * @param \Magento\Framework\App\RequestInterface $request
     * @return $this|bool
     */
    public function hasRedirect(\Magento\Framework\App\RequestInterface $request)
    {
        $redirect = $this->load($request->getPathInfo(), 'requested_path');
        if (empty($redirect->getId())) {
            $redirect = $this->load(rtrim($request->getPathInfo(), '/'), 'requested_path');
        }
        return $redirect->getId() ? $redirect : false;
    }
}
