<?php
namespace Pinpoint\RedirectManager\Ui\Component\Listing\DataProviders\Pinpoint\Redirectmanager;

/**
 * Class Log404
 * @package Pinpoint\RedirectManager\Ui\Component\Listing\DataProviders\Pinpoint\Redirectmanager
 */
class Log404 extends \Magento\Ui\DataProvider\AbstractDataProvider
{
    /**
     * Log404 constructor.
     * @param string $name
     * @param string $primaryFieldName
     * @param string $requestFieldName
     * @param \Pinpoint\RedirectManager\Model\ResourceModel\NotFound\CollectionFactory $collectionFactory
     * @param array $meta
     * @param array $data
     */
    public function __construct(
        $name,
        $primaryFieldName,
        $requestFieldName,
        \Pinpoint\RedirectManager\Model\ResourceModel\NotFound\CollectionFactory $collectionFactory,
        array $meta = [],
        array $data = []
    ) {
        parent::__construct($name, $primaryFieldName, $requestFieldName, $meta, $data);
        $this->collection = $collectionFactory->create();
    }

    /**
     * @return array
     */
    public function getData()
    {
        $log = parent::getData();

        $stats = $this->getCollection()->getSelect()->reset()
            ->from('pinpoint_rm_404_log')
            ->columns('id')
            ->columns('COUNT(*) AS count')
            ->group('requested_path')
            ->query()->fetchAll()
        ;

        $i = 0;
        foreach ($log['items'] as $notfound) {
            if ($count = $this->getNotFoundCount($notfound['requested_path'], $stats)) {
                $log['items'][$i]['count'] = $count;
            }
            $i++;
        }

        return $log;
    }

    /**
     * @param $requestedPath
     * @param $stats
     * @return int
     */
    protected function getNotFoundCount($requestedPath, $stats)
    {
        foreach ($stats as $stat) {
            if ($stat['requested_path'] == $requestedPath) {
                return $stat['count'];
            }
        }

        return 1;
    }
}
